term.out ('entered installer')




vmvsslfi = vessel.get_focusinterface()

oldspkyaw = vmvsslfi:get_yaw()
oldsimt= oapi.get_simtime()-1

term.out('fi,yaw and simt vars initialized.')



-- Set up autopilot structures

vi = vmvsslfi

aap = {}
aap.altid = nil
aap.spdid = nil
aap.bnkid = nil
aap.hdgid = nil
aap.tgtalt = nil
aap.tgtspd = nil
aap.tgtbnk = nil
aap.tgthdg = nil
aap.maxasc = 60 --maximum ascent in degrees
aap.maxdsc = -10 --maximum descent in degrees



--aap globals

RAD = math.pi/180

--altitude ap
dslope = 0
dslope0 = 0
dslope_rate = 0 

-- speed ap
spd0 = vi:get_airspeed()

--heading ap
hdg0 = vi:get_yaw()

--bank ap
bnk0 = vi:get_bank()


term.out('Autopilot vars initialized')


--******************************************************
-- Autopilot Section
--Adapted from Deltaglider Orbiter Original /Script/DG/aap.lua
--******************************************************


function altitude ()
    alt = vi:get_altitude()
    return alt
end

function airspeed ()
    return vi:get_airspeed()
end

function slope ()
    as = vi:get_horizonairspeedvector()
    xz = math.sqrt (as.x^2 + as.z^2)
    sl = math.atan2 (as.y, xz)
    return sl
end



function alt_ap_through_bank(alt,bank)

    aap.tgtalt = alt

    if aap.tgtalt ~= nil then
        local dt = oapi.get_simstep()
        alt = altitude() 
        dalt = aap.tgtalt-alt
        tgt_slope = math.atan2(dalt, airspeed ()*120) --two minute climbs or descents
	    if tgt_slope > aap.maxasc * RAD then
	        tgt_slope = aap.maxasc * RAD
        elseif tgt_slope < aap.maxdsc * RAD then
	        tgt_slope = aap.maxdsc * RAD
        end
        dslope = tgt_slope-slope()
        if dslope0 == 0 then
            dslope_rate = 0
        else
            dslope_rate = (dslope-dslope0)/dt
		end
        dslope0 = 2 * dslope - dslope_rate
		dbank = dslope 
        actbank = bank - dbank 
		if actbank> math.pi/2 then actbank = math.pi/2 end
		if actbank<0 then actbank = 0 end
		--***************DEBUGDEBUGDEBUG**************
		--oapi.dbg_out('tgt_slope:'..tgt_slope*180/math.pi..'actbank:'..actbank*180/math.pi)
		return actbank
    end

end


function spd_ap (spd)
    if spd ~= nil then aap.tgtspd = spd end
    local acc, dpsd
    local alpha = 1
    local beta = 1

        if aap.tgtspd ~= nil then
            local dt = oapi.get_simstep()
            spd = airspeed()
            acc = (spd-spd0)/dt
            spd0 = spd
            dspd = aap.tgtspd-spd
            dthrott = (dspd*alpha - acc*beta)*dt
            thrott = vi:get_thrustergrouplevel (THGROUP.MAIN)
            vi:set_thrustergrouplevel (THGROUP.MAIN, thrott+dthrott)
		end

end


function bank_ap (bnk)
    aap.tgtbnk = bnk

        local dt = oapi.get_simstep()
        bnk = vi:get_bank()
        dbnk = bnk-bnk0
        if dbnk < -PI then dbnk = dbnk+2*PI elseif dbnk > PI then dbnk = dbnk-2*PI end -- phase unwrap
        rate = dbnk/dt
        bnk0 = bnk
        dbnk = aap.tgtbnk - bnk
        if dbnk < -PI then dbnk = dbnk+2*PI elseif dbnk > PI then dbnk = dbnk-2*PI end -- phase unwrap
        dail = (-dbnk*0.1 + rate*0.3)*(dt*5.0) -- the damping term should really depend on atmospheric density
        ail = vi:get_adclevel(AIRCTRL.AILERON)
        ail = ail+dail
        if ail > 1 then ail = 1 elseif ail < -1 then ail = -1 end
        vi:set_adclevel(AIRCTRL.AILERON,ail)

end



--Main Function
--*********************


function spk_flt( spkbank , spkvelocity)

	term.out('\n*****************************************')
	term.out ('            Entered AP Function')
	term.out('Activate RCS (to ROT or LIN) to exit')
	term.out('*****************************************')

	hspkannotation =  oapi.create_annotation()
	hspkannotation:set_pos(.75,.2,1,1)
	hspkannotation:set_size(.5)
	term.out('Annotation created, positioned and scaled.')

	vmvsslfi:set_rcsmode(RCSMODE.OFF)
	spookylevel = 1.0
	vmvsslfi:set_adclevel(AIRCTRL.ELEVATOR,spookylevel)

	setbank = spkbank

	--k=0
	--while k< 10 do --TESTE

	while vmvsslfi:get_rcsmode()== RCSMODE.OFF do

		--term.out('entered loop')

		simt= oapi.get_simtime()
		spd_ap(spkvelocity)
		--term.out('passed vel ap')
		bank_ap (setbank)
		--term.out('passed bank ap')
		spkyaw = vmvsslfi:get_yaw()

		--Spooky Flight Calculations....
		if (simt-oldsimt) ~= 0 then 
			spkangvel = math.abs(spkyaw - oldspkyaw)/(simt-oldsimt)
			oldspkyaw = spkyaw
			oldsimt = simt
			if spkbank ~= 0 and math.abs(spkbank) < math.pi/2 then
				spkTaltitude= spkvelocity/spkangvel*math.atan(spkbank)
				spkTradius = math.atan(spkbank)/spkTaltitude
				spkTdistance = spkTaltitude/math.sin(spkbank)
				hspkannotation:set_text('Spooky Flight Ideal Altitude:\n'..string.format('%0.2f',spkTaltitude)..'m')
			end
		end

		setbank = alt_ap_through_bank(spkTaltitude,spkbank)

		proc.skip()

		--k=k+1

	end

	oapi.del_annotation(hspkannotation)
	--Restoring
	vmvsslfi:set_adclevel(AIRCTRL.ELEVATOR,0)
	vmvsslfi:set_adclevel(AIRCTRL.AILERON,0)
	vmvsslfi:set_adcmode(7)

	term.out('Exiting Function')

end

term.out('Spooky Flight Function Defined')

function sfmn(bkg,vl)

	spkproc = proc.bg(spk_flt(bkg*math.pi/180,vl))

end
term.out('\n*****************************************')
term.out('          Spooky Flight AP Installed.')
term.out('*****************************************')
term.out('Enter "sfmn(bank_angle,speed)" to start')
term.out('*****************************************')